Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 1672711 - Upgrade from glusterfs 3.12 to gluster 4/5 broken [NEEDINFO]
Summary: Upgrade from glusterfs 3.12 to gluster 4/5 broken
Keywords:
Status: CLOSED NEXTRELEASE
Alias: None
Product: GlusterFS
Classification: Community
Component: packaging
Version: mainline
Hardware: Unspecified
OS: Unspecified
urgent
urgent
Target Milestone: ---
Assignee: bugs@gluster.org
QA Contact:
URL:
Whiteboard:
Depends On:
Blocks: Gluster_5_Affecting_oVirt_4.3 1679965 1679968
TreeView+ depends on / blocked
 
Reported: 2019-02-05 16:34 UTC by Sahina Bose
Modified: 2019-02-22 11:20 UTC (History)
7 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
: 1679965 1679968 (view as bug list)
Environment:
Last Closed: 2019-02-22 11:08:33 UTC
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
sabose: needinfo? (kkeithle)


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Gluster.org Gerrit 22190 None Merged packaging: Obsoleting glusterfs-gnfs for upgrade 2019-02-22 11:08:31 UTC

Description Sahina Bose 2019-02-05 16:34:47 UTC
Description of problem:

While updating glusterfs 3.12, run into below error :
Error: Package: glusterfs-gnfs-3.12.15-1.el7.x86_64 (@ovirt-4.2-centos-gluster312)
           Requires: glusterfs(x86-64) = 3.12.15-1.el7
           Removing: glusterfs-3.12.15-1.el7.x86_64 (@ovirt-4.2-centos-gluster312)
               glusterfs(x86-64) = 3.12.15-1.el7
           Updated By: glusterfs-5.3-1.el7.x86_64 (ovirt-4.3-centos-gluster5)
               glusterfs(x86-64) = 5.3-1.el7



Version-Release number of selected component (if applicable):
3.12

How reproducible:
Always

Comment 1 Sahina Bose 2019-02-06 05:43:58 UTC
Jiffin, can you help with this?

Comment 2 Worker Ant 2019-02-11 10:59:16 UTC
REVIEW: https://review.gluster.org/22190 (packagaing : check lower version for gluster-gnfs incase of upgrade) posted (#1) for review on master by jiffin tony Thottan

Comment 3 Kaleb KEITHLEY 2019-02-12 13:19:09 UTC
This is because gnfs is has been deprecated (for a long time now) and the glusterfs-gnfs subpackage is no longer built for the CentOS Storage SIG packages starting with GlusterFS-5.

If you manually remove the glusterfs-gnfs package first, then update, the update will work.

(Are you using NFS even? If not, then you don't need -gnfs in the first place. If you are, there is NFS-Ganesha.)

Comment 4 Kaleb KEITHLEY 2019-02-15 12:49:55 UTC
Does removing glusterfs-gnfs manually/explicitly, followed by update, work?

AFAIK oVirt doesn't use NFS at all and never needed glusterfs-gnfs in the first place.

If glusterfs-gnfs was being used on the same system for something else, it should be replaced with a nfs-ganesha deployment, also from the Storage SIG.

And you can't use an old version of glusterfs-gnfs (e.g. 3.12.x) with glusterfs-5.x.

I will close this as NOTABUG in a few days unless I hear back.

Comment 5 Sahina Bose 2019-02-15 13:56:06 UTC
(In reply to Kaleb KEITHLEY from comment #4)
> Does removing glusterfs-gnfs manually/explicitly, followed by update, work?

That works, but is not the option that we want to provide users. Since updates happen from UI, we want this to be as seamless as possible. 
> 
> AFAIK oVirt doesn't use NFS at all and never needed glusterfs-gnfs in the
> first place.

OVirt users who use nfs option to mount gluster, do use glusterfs-gnfs. And we had a dependency on glusterfs-gnfs to workaround an earlier bug, so this package is now available on all hosts.

> 
> If glusterfs-gnfs was being used on the same system for something else, it
> should be replaced with a nfs-ganesha deployment, also from the Storage SIG.
> 
> And you can't use an old version of glusterfs-gnfs (e.g. 3.12.x) with
> glusterfs-5.x.
> 
> I will close this as NOTABUG in a few days unless I hear back.


We want the upgrade from 3.12 to > 4 versions to work. So adding Obsoletes in glusterfs spec as suggested by others - is this a possible option?

Comment 6 Strahil Nikolov 2019-02-20 20:20:19 UTC
It seems that glusterfs-gnfs is a depedency for vdsm-gluster without which I was not able to deploy ovirt-4.2.7 self-hosted (prep stage failed as method "gluster" was unknown):
[root@ovirt2 ~]# yum --assumeno remove glusterfs-gnfs
Loaded plugins: enabled_repos_upload, fastestmirror, package_upload, product-id, search-disabled-repos, subscription-manager, vdsmupgrade
This system is not registered with an entitlement server. You can use subscription-manager to register.
Repository centos-sclo-rh-release is listed more than once in the configuration
Resolving Dependencies
--> Running transaction check
---> Package glusterfs-gnfs.x86_64 0:3.12.15-1.el7 will be erased
--> Processing Dependency: glusterfs-gnfs for package: vdsm-gluster-4.20.46-1.el7.x86_64
--> Running transaction check
---> Package vdsm-gluster.x86_64 0:4.20.46-1.el7 will be erased
--> Finished Dependency Resolution

Dependencies Resolved

=======================================================================================================================================================
 Package                           Arch                      Version                             Repository                                       Size
=======================================================================================================================================================
Removing:
 glusterfs-gnfs                    x86_64                    3.12.15-1.el7                       @ovirt-4.2-centos-gluster312                    445 k
Removing for dependencies:
 vdsm-gluster                      x86_64                    4.20.46-1.el7                       @ovirt-4.2                                      260 k

Transaction Summary
=======================================================================================================================================================
Remove  1 Package (+1 Dependent package)

Installed size: 705 k
Exiting on user command
Your transaction was saved, rerun it with:
 yum load-transaction /tmp/yum_save_tx.2019-02-20.22-19.2e8Lcz.yumtx
Uploading Enabled Repositories Report
Loaded plugins: fastestmirror, product-id, subscription-manager
This system is not registered with an entitlement server. You can use subscription-manager to register.
Repository centos-sclo-rh-release is listed more than once in the configuration
Cannot upload enabled repos report, is this client registered?

Comment 7 Strahil Nikolov 2019-02-20 20:53:27 UTC
I have removed glusterfs-gnfs manually and updated.
The update process finished successfully, but the web interface shows unsynced entries present , while gluster volume heal engine info - shows nothing...

Comment 8 Strahil Nikolov 2019-02-20 20:55:41 UTC
(In reply to Strahil Nikolov from comment #7)
> I have removed glusterfs-gnfs manually and updated.
> The update process finished successfully, but the web interface shows
> unsynced entries present , while gluster volume heal engine info - shows
> nothing...

rpm -e --nodeps glusterfs-gnfs

Comment 9 Jiffin 2019-02-21 18:12:24 UTC
# yum update glusterfs-4.1.7-0.3.git397ef0c.el7.x86_64.rpm  glusterfs-libs-4.1.7-0.3.git397ef0c.el7.x86_64.rpm glusterfs-api-4.1.7-0.3.git397ef0c.el7.x86_64.rpm  glusterfs-client-xlators-4.1.7-0.3.git397ef0c.el7.x86_64.rpm 
Loaded plugins: fastestmirror, ovl
Examining glusterfs-4.1.7-0.3.git397ef0c.el7.x86_64.rpm: glusterfs-4.1.7-0.3.git397ef0c.el7.x86_64
Marking glusterfs-4.1.7-0.3.git397ef0c.el7.x86_64.rpm as an update to glusterfs-3.12.15-0.0.el7.x86_64
Examining glusterfs-libs-4.1.7-0.3.git397ef0c.el7.x86_64.rpm: glusterfs-libs-4.1.7-0.3.git397ef0c.el7.x86_64
Marking glusterfs-libs-4.1.7-0.3.git397ef0c.el7.x86_64.rpm as an update to glusterfs-libs-3.12.15-0.0.el7.x86_64
Examining glusterfs-api-4.1.7-0.3.git397ef0c.el7.x86_64.rpm: glusterfs-api-4.1.7-0.3.git397ef0c.el7.x86_64
Marking glusterfs-api-4.1.7-0.3.git397ef0c.el7.x86_64.rpm as an update to glusterfs-api-3.12.15-0.0.el7.x86_64
Examining glusterfs-client-xlators-4.1.7-0.3.git397ef0c.el7.x86_64.rpm: glusterfs-client-xlators-4.1.7-0.3.git397ef0c.el7.x86_64
Marking glusterfs-client-xlators-4.1.7-0.3.git397ef0c.el7.x86_64.rpm as an update to glusterfs-client-xlators-3.12.15-0.0.el7.x86_64
Resolving Dependencies
--> Running transaction check
---> Package glusterfs.x86_64 0:3.12.15-0.0.el7 will be updated
---> Package glusterfs.x86_64 0:4.1.7-0.3.git397ef0c.el7 will be obsoleting
---> Package glusterfs-api.x86_64 0:3.12.15-0.0.el7 will be updated
---> Package glusterfs-api.x86_64 0:4.1.7-0.3.git397ef0c.el7 will be an update
---> Package glusterfs-client-xlators.x86_64 0:3.12.15-0.0.el7 will be updated
---> Package glusterfs-client-xlators.x86_64 0:4.1.7-0.3.git397ef0c.el7 will be an update
---> Package glusterfs-gnfs.x86_64 0:3.12.15-0.0.el7 will be obsoleted
---> Package glusterfs-libs.x86_64 0:3.12.15-0.0.el7 will be updated
---> Package glusterfs-libs.x86_64 0:4.1.7-0.3.git397ef0c.el7 will be an update
--> Finished Dependency Resolution

Dependencies Resolved

===================================================================================================================================================================================================================
 Package                                        Arch                         Version                                         Repository                                                                       Size
===================================================================================================================================================================================================================
Installing:
 glusterfs                                      x86_64                       4.1.7-0.3.git397ef0c.el7                        /glusterfs-4.1.7-0.3.git397ef0c.el7.x86_64                                      2.5 M
     replacing  glusterfs-gnfs.x86_64 3.12.15-0.0.el7
Updating:
 glusterfs-api                                  x86_64                       4.1.7-0.3.git397ef0c.el7                        /glusterfs-api-4.1.7-0.3.git397ef0c.el7.x86_64                                  197 k
 glusterfs-client-xlators                       x86_64                       4.1.7-0.3.git397ef0c.el7                        /glusterfs-client-xlators-4.1.7-0.3.git397ef0c.el7.x86_64                       4.8 M
 glusterfs-libs                                 x86_64                       4.1.7-0.3.git397ef0c.el7                        /glusterfs-libs-4.1.7-0.3.git397ef0c.el7.x86_64                                 1.3 M

Transaction Summary
===================================================================================================================================================================================================================
Install  1 Package
Upgrade  3 Packages

Total size: 8.9 M
Is this ok [y/d/N]: y
Downloading packages:
Running transaction check
Running transaction test
Transaction test succeeded
Running transaction
  Updating   : glusterfs-libs-4.1.7-0.3.git397ef0c.el7.x86_64                                                                                                                                                  1/9 
  Installing : glusterfs-4.1.7-0.3.git397ef0c.el7.x86_64                                                                                                                                                       2/9 
  Updating   : glusterfs-client-xlators-4.1.7-0.3.git397ef0c.el7.x86_64                                                                                                                                        3/9 
  Updating   : glusterfs-api-4.1.7-0.3.git397ef0c.el7.x86_64                                                                                                                                                   4/9 
  Erasing    : glusterfs-gnfs-3.12.15-0.0.el7.x86_64                                                                                                                                                           5/9 
  Cleanup    : glusterfs-api-3.12.15-0.0.el7.x86_64                                                                                                                                                            6/9 
  Cleanup    : glusterfs-3.12.15-0.0.el7.x86_64                                                                                                                                                                7/9 
  Cleanup    : glusterfs-client-xlators-3.12.15-0.0.el7.x86_64                                                                                                                                                 8/9 
  Cleanup    : glusterfs-libs-3.12.15-0.0.el7.x86_64                                                                                                                                                           9/9 
  Verifying  : glusterfs-libs-4.1.7-0.3.git397ef0c.el7.x86_64                                                                                                                                                  1/9 
  Verifying  : glusterfs-api-4.1.7-0.3.git397ef0c.el7.x86_64                                                                                                                                                   2/9 
  Verifying  : glusterfs-4.1.7-0.3.git397ef0c.el7.x86_64                                                                                                                                                       3/9 
  Verifying  : glusterfs-client-xlators-4.1.7-0.3.git397ef0c.el7.x86_64                                                                                                                                        4/9 
  Verifying  : glusterfs-gnfs-3.12.15-0.0.el7.x86_64                                                                                                                                                           5/9 
  Verifying  : glusterfs-libs-3.12.15-0.0.el7.x86_64                                                                                                                                                           6/9 
  Verifying  : glusterfs-3.12.15-0.0.el7.x86_64                                                                                                                                                                7/9 
  Verifying  : glusterfs-api-3.12.15-0.0.el7.x86_64                                                                                                                                                            8/9 
  Verifying  : glusterfs-client-xlators-3.12.15-0.0.el7.x86_64                                                                                                                                                 9/9 

Installed:
  glusterfs.x86_64 0:4.1.7-0.3.git397ef0c.el7                                                                                                                                                                      

Updated:
  glusterfs-api.x86_64 0:4.1.7-0.3.git397ef0c.el7                   glusterfs-client-xlators.x86_64 0:4.1.7-0.3.git397ef0c.el7                   glusterfs-libs.x86_64 0:4.1.7-0.3.git397ef0c.el7                  

Replaced:
  glusterfs-gnfs.x86_64 0:3.12.15-0.0.el7                                                                                                                                                                          

posted the patch https://review.gluster.org/#/c/glusterfs/+/22190/ to fix this

Comment 10 Worker Ant 2019-02-22 11:08:33 UTC
REVIEW: https://review.gluster.org/22190 (packaging: Obsoleting glusterfs-gnfs for upgrade) merged (#4) on master by Niels de Vos


Note You need to log in before you can comment on or make changes to this bug.